#include <stdio.h>
#include <stdlib.h>
#include <Limits.h>
#include "Listas.h"
#include "Estruturas.h"
#include "Util.h"
#include "Construcao.h"

void constroi_solucao(int n, int *s, float **distancia)
{
    for (int j=0; j < n; j++) s[j] = j;
}


/* Constroi uma solucao pela Heuristica do vizinho mais proximo */
void constroi_solucao_gulosa_vizinho_mais_proximo(int n, int *s, float **d)
{
    struct lista *inicio_LC, *final_LC, *nao_visitada;
    int tamanho_LC;

    /* Inicio da Fase de Construcao de uma solucao */
    printf("\n Construindo nova solucao ...\n");
    inicio_LC = final_LC = NULL;
    for (int j=1; j<n; j++){
      nao_visitada = (struct lista *)malloc(sizeof(struct lista));
      if (!nao_visitada) {
         printf("Faltando memoria ...\n");
         exit(1);
      }
      /* vou inserir um registro no final de uma lista  */
      nao_visitada->campo1 = j;
      nao_visitada->campo2 = 0;
      insere_final_lista(nao_visitada, &inicio_LC, &final_LC);
      tamanho_LC = tamanho_lista(&inicio_LC, &final_LC);
//      printf("Tamanho da LC = %2d \n", tamanho_LC);
//      mostra_lista(&inicio_LC, &final_LC);
    }
    s[0]=0;  /* A cidade origem  a cidade 0 */

    int j = 1;
    int mais_proxima;
    float dist;
    while (j < n){
      dist = INT_MAX;
      struct lista *registro = inicio_LC;
      int pos = 1;
      while (registro) {
//        printf("L[%2d]   campo1 = %2d  campo2 = %2d  \n",
//               pos, registro->campo1, registro->campo2);
        if (d[s[j-1]][registro->campo1] < dist){
          dist = d[s[j-1]][registro->campo1];
          mais_proxima = registro->campo1;
        }
        registro = registro->proximo;   // obtem prximo endereo
        pos++;
      }
      /* Insere a cidade mais proxima apos a ultima cidade inserida*/
      s[j] = mais_proxima;
      /* Apaga a cidade mais_proxima da lista de nao visitadas */
      registro = encontra_registro(mais_proxima, 0,&inicio_LC);
      apaga_registro(registro,&inicio_LC,&final_LC);
//      mostra_lista(&inicio_LC, &final_LC);
      j++;
    }
}





